<?php
/**
 * @package Bizarski Cute Records
 */
/*
Plugin Name: Bizarski Cute Records
Description: Album management for musicians. For documentation, visit my website. 
Plugin URI: http://cuteplugins.com/wordpress-cute-records/
Version: 1.0.0
Author: Bizarski
License: GPLv2 or later
*/

$cuterecords_cover_w = get_option('cuterecords_cover_w');
$cuterecords_cover_w = $cuterecords_cover_w ? $cuterecords_cover_w : 500;
$cuterecords_cover_h = get_option('cuterecords_cover_h');
$cuterecords_cover_h = $cuterecords_cover_h ? $cuterecords_cover_h : 500;

$cuterecords_thumb_w = get_option('cuterecords_thumb_w');
$cuterecords_thumb_w = $cuterecords_thumb_w ? $cuterecords_thumb_w : 200;
$cuterecords_thumb_h = get_option('cuterecords_thumb_h');
$cuterecords_thumb_h = $cuterecords_thumb_h ? $cuterecords_thumb_h : 200;

$cuterecords_side_w = get_option('cuterecords_side_w');
$cuterecords_side_w = $cuterecords_side_w ? $cuterecords_side_w : 200;
$cuterecords_side_h = get_option('cuterecords_side_h');
$cuterecords_side_h = $cuterecords_side_h ? $cuterecords_side_h : 200;

$cuterecords_cont_css = get_option('cuterecords_cont_css');
$cuterecords_cont_css = $cuterecords_cont_css ? $cuterecords_cont_css : 'width: 500px; background: rgba(0,0,0,.1); color: #000; padding: 10px';

$cuterecords_trklst_css = get_option('cuterecords_trklst_css');
$cuterecords_trklst_css = $cuterecords_trklst_css ? $cuterecords_trklst_css : 'width: 520px; background: rgba(0,0,0,.1); color: #000; ';

$cuterecords_lyr_css = get_option('cuterecords_lyr_css');
$cuterecords_lyr_css = $cuterecords_lyr_css ? $cuterecords_lyr_css : 'width: 520px; background: #fff; color: #000; ';

define('cuterecords_COVER_WIDTH', $cuterecords_cover_w);
define('cuterecords_COVER_HEIGHT', $cuterecords_cover_h);
define('cuterecords_THUMB_WIDTH', $cuterecords_thumb_w);
define('cuterecords_THUMB_HEIGHT', $cuterecords_thumb_h);
define('cuterecords_SIDE_WIDTH', $cuterecords_side_w);
define('cuterecords_SIDE_HEIGHT', $cuterecords_side_h);
define('cuterecords_CONT_CSS', $cuterecords_cont_css);
define('cuterecords_TRKLST_CSS', $cuterecords_trklst_css);
define('cuterecords_LYR_CSS', $cuterecords_lyr_css);

define('cuterecords_VERSION', '1.0.0');
define('cuterecords_PLUGIN_URL', plugin_dir_url( __FILE__ ));
define('cuterecords_PLUGIN_PATH', dirname(__FILE__));

//define('cuterecords_DIRS', '\\'); //localhost
define('cuterecords_DIRS', '/');

// Make sure we don't expose any info if called directly
if ( !function_exists( 'add_action' ) ) {
	echo "Hi there!  I'm just a plugin, not much I can do when called directly.";
	exit;
}

include_once dirname( __FILE__ ) . '/widget.php';

class BizarskiCuteRecords { 

	function init() { 
		if(is_admin()) { 
			self::battle_scripts();
			wp_register_script('cuterecords.js.php', cuterecords_PLUGIN_URL . 'cuterecords.js.php', array('jquery'));
			wp_enqueue_script('cuterecords.js.php');
		} else { 
			wp_register_script('cuterecords.front.js.php', cuterecords_PLUGIN_URL . 'cuterecords.front.js.php', array('jquery'));
			wp_enqueue_script('cuterecords.front.js.php');
		}
	
		wp_register_style('cuterecords.css', cuterecords_PLUGIN_URL . 'cuterecords.css');
		wp_enqueue_style('cuterecords.css');
		

		if (!session_id()) {
			session_start();
		}
	}
	
	function admin() {
		if(is_super_admin()) { 
			require_once dirname( __FILE__ ) . '/include/admin.php';
		}
	}
	
	function admin_tracks() {
		if(is_super_admin()) { 
			require_once dirname( __FILE__ ) . '/include/admin_tracks.php';
		}
	}
	
	function admin_settings() {
		if(is_super_admin()) { 
			require_once dirname( __FILE__ ) . '/include/admin_settings.php';
		}
	}
	
	function admin_actions() {
		if(is_super_admin()) { 
			add_menu_page("Cute Gigs", "Cute Records", 'add_users', "cuterecords-admin", array("BizarskiCuteRecords", "admin"), false, 7);
			add_submenu_page("cuterecords-admin", "Manage Records", "Manage Records", 'add_users', 'cuterecords-admin', array("BizarskiCuteRecords", "admin"));
			add_submenu_page("cuterecords-admin", "Manage Tracks", "Manage Tracks", 'add_users', 'cuterecords-tracks', array("BizarskiCuteRecords", "admin_tracks"));
			add_submenu_page("cuterecords-admin", "Settings", "Settings", 'add_users', 'cuterecords-settings', array("BizarskiCuteRecords", "admin_settings"));
		}
	}
	
	function battle_scripts() { 
		wp_register_script('jquery.ui.core.js', cuterecords_PLUGIN_URL . 'script/jquery.ui.core.js');
		wp_enqueue_script('jquery.ui.core.js');
		wp_register_script('jquery.ui.widget.js', cuterecords_PLUGIN_URL . 'script/jquery.ui.widget.js');
		wp_enqueue_script('jquery.ui.widget.js');
		wp_register_script('datepicker.js', cuterecords_PLUGIN_URL . 'script/datepicker.js');
		wp_enqueue_script('datepicker.js');
		
		wp_register_style('jquery.ui.all.css', cuterecords_PLUGIN_URL . 'script/base/jquery.ui.all.css');
		wp_enqueue_style('jquery.ui.all.css');
		wp_register_style('datePicker.css', cuterecords_PLUGIN_URL . 'script/datePicker.css');
		wp_enqueue_style('datePicker.css');
	}
	
	function install() { 
		global $wpdb;
		
		$table = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."cuterecords` (
		`id` int(11) NOT NULL auto_increment,
		`name` varchar(128) default NULL,
		`type` varchar(64) default NULL,
		`time` varchar(64) default NULL,
		`format` varchar(64) default NULL,
		`url` varchar(128) default NULL,
		`label` varchar(128) default NULL,
		`releasedate` DATE NOT NULL DEFAULT '0000-00-00', 
		`cover` varchar(128) default NULL,
		PRIMARY KEY  (`id`) 
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";

		$wpdb->query($table);
		
		$table = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."cuterecords_tracks` (
		`id` int(11) NOT NULL auto_increment,
		`record_id` int(11) NOT NULL DEFAULT '0', 
		`songnum` SMALLINT NOT NULL DEFAULT '0', 
		`name` varchar(128) default NULL,
		`lyrics` text,
		`time` varchar(64) default NULL,
		PRIMARY KEY  (`id`), 
		KEY `record_id` (`record_id`)
		) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";

		$wpdb->query($table);
		
	}
	
	function display_records($args) { 
		global $wpdb; 
		$limit = $args['limit'] ? " LIMIT ".$args['limit']." " : '';
		$offset = $args['offset'] ? " OFFSET ".$args['offset']." " : '';
		$results = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."cuterecords ORDER BY releasedate DESC".$limit.$offset);
		$content = '';
		if(count($results) > 0) { 
			foreach($results as $rec) { 
				$content .= '<div class="cuterecords_container" style="'.cuterecords_CONT_CSS.'">';
				$content .= '<a target="blank" href="'.esc_attr($rec->url).'"><img alt="" src="'.cuterecords_PLUGIN_URL.'covers/thumbs/'.esc_attr($rec->cover).'" width="'.cuterecords_THUMB_WIDTH.'"></a>';
				$content .= '<div class="cuterecords_details_cont">';
				$content .= '<h3 class="cuterecords_name">"'.stripslashes($rec->name).'"</h3><br>';
				$content .= '<p class="cuterecords_details"><span class="cuterecords_releasedate">'.date("Y", strtotime($rec->releasedate)).'</span>, <span class="cuterecords_type">'.stripslashes($rec->type).'</span>, <span class="cuterecords_format">'.stripslashes($rec->format).'</span></p><br>';
				$content .= '<p class="cuterecords_details"><span class="cuterecords_label">'.stripslashes($rec->label).'</span></p>';
				$content .= '</div>';
				$content .= '</div>';
			}
		} 
		return $content;
	}
	
	function show_cover($args) { 
		global $wpdb; 
		$results = $wpdb->get_row("SELECT cover FROM ".$wpdb->prefix."cuterecords WHERE id='".$args['id']."'");
		$content = '<img alt="" src="'.cuterecords_PLUGIN_URL.'covers/thumbs/'.esc_attr($results->cover).'" width="'.cuterecords_THUMB_WIDTH.'">';
		return $content; 
	}
	
	function show_full_cover($args) { 
		global $wpdb; 
		$results = $wpdb->get_row("SELECT cover FROM ".$wpdb->prefix."cuterecords WHERE id='".$args['id']."'");
		$content = '<img alt="" src="'.cuterecords_PLUGIN_URL.'covers/'.esc_attr($results->cover).'" width="'.cuterecords_COVER_WIDTH.'">';
		return $content; 
	}
	
	function tracklist($args) { 
		global $wpdb; 
		$content = '';
		$results = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."cuterecords_tracks WHERE record_id='".$args['id']."'");
		if(count($results) > 0) { 
			$content .= '<table class="cuterecords_table" style="'.cuterecords_TRKLST_CSS.'">';
			$content .= '<tr><th width="8%">#</th><th width="80%">Title</th><th width="12%">Length</th></tr>';
			foreach($results as $track) { 
				$content .= '<tr><td valign="top">'.$track->songnum.'</td><td valign="top">';
				if($track->lyrics && $track->lyrics != '') { 
					$content .= stripslashes($track->name).' <a href="#cuterecords_lyrics_'.$track->id.'" class="cuterecords_display_lyrics">(view lyrics)</a>';
					$content .= '<div style="display: none">';
					$content .= '<div class="cuterecords_lyrics" id="cuterecords_lyrics_'.$track->id.'" style="'.cuterecords_LYR_CSS.'">';
					$content .= '<h2>'.stripslashes($track->name).'</h2>';
					$content .= stripslashes(nl2br($track->lyrics));
					$content .= '</div>';
					$content .= '</div>';
				} else { 
					$content .= stripslashes($track->name);
				}
				$content .= '</td><td valign="top">'.stripslashes($track->time).'</td></tr>';
			}
			$content .= '</table>';
		}
		return $content; 
	}
	
}

register_activation_hook(__FILE__,array('BizarskiCuteRecords', 'install'));
add_action('init', array('BizarskiCuteRecords', 'init'));
add_action('admin_menu', array('BizarskiCuteRecords', 'admin_actions') );
add_shortcode('cuterecords_display', array('BizarskiCuteRecords', 'display_records'));
add_shortcode('cuterecords_show_cover', array('BizarskiCuteRecords', 'show_cover'));
add_shortcode('cuterecords_show_full_cover', array('BizarskiCuteRecords', 'show_full_cover'));
add_shortcode('cuterecords_tracklist', array('BizarskiCuteRecords', 'tracklist'));